ifndef _CBButton_
_CBButton_ equ 1

; --=====================================================================================--
; #CLASS:    CFButton
; #VERSION:  1.0
; --=====================================================================================--
; Built by NaN's Object Class Creator
;  Sept 19, 2001
;
; By NaN ( jaymeson@hotmail.com )
; http://nan32asm.cjb.net
;
; --=====================================================================================--
; #AUTHOR: Smallwaves
; #DATE:   Jan,12, 2002
;
; #DESCRIPTION:
;
;          Masm32 Flat Button Class V1.02.
;          (<b>FLAT BUTTON</b>)..
;
; --=====================================================================================--
; CLASS METHOD PROTOS
; --=====================================================================================--
   CFButton_Init    PROTO  :DWORD, :DWORD, :DWORD, :DWORD, :DWORD

; --=====================================================================================--
; FUNCTION POINTER PROTOS
; --=====================================================================================--
   CBBu_destructorPto    TYPEDEF  PROTO  :DWORD
   CBBu_GetFlatPto		 TYPEDEF   PROTO	:DWORD
   CBBu_SetFlatPto		 TYPEDEF   PROTO	:DWORD, :DWORD
   CBBu_DrawItemPto      TYPEDEF   PROTO  :DWORD, :DWORD 
   CBBu_GetTextPto		 TYPEDEF	PROTO	:DWORD
   CBBu_SetTextPto		 TYPEDEF	PROTO  :DWORD, :DWORD   
   CBBu_GetActiveTextColPto TYPEDEF PROTO :DWORD
   CBBu_SetActiveTextColPto TYPEDEF PROTO :DWORD, :DWORD
   CBBu_GetInactiveTextColPto TYPEDEF PROTO :DWORD	   
   CBBu_SetInactiveTextColPto TYPEDEF PROTO :DWORD, :DWORD
   CBBu_GetActiveBkColPto	  TYPEDEF PROTO :DWORD   
   CBBu_SetActiveBkColPto	  TYPEDEF PROTO :DWORD, :DWORD
   CBBu_GetInactiveBkColPto   TYPEDEF PROTO :DWORD   
   CBBu_SetInactiveBkColPto   TYPEDEF PROTO :DWORD, :DWORD
   CBBu_GetActiveIconPto	  TYPEDEF PROTO :DWORD
   CBBu_SetActiveIconPto	  TYPEDEF PROTO :DWORD, :DWORD, :DWORD   
   CBBu_GetHandlePto    TYPEDEF  PROTO  :DWORD   
   CBBu_GetIconBtnPto	 TYPEDEF  PROTO  :DWORD
   CBBu_SetIconBtnPto    TYPEDEF  PROTO  :DWORD, :DWORD, :DWORD
   CBBu_GetCursorPto	 TYPEDEF	PROTO  :DWORD
   CBBu_SetCursorPto	 TYPEDEF	PROTO  :DWORD, :DWORD, :DWORD
   CBBu_IconBtnProcPto	 TYPEDEF	PROTO	:DWORD, :DWORD, :DWORD, :DWORD	   
; --=====================================================================================--
; CLASS STRUCTURE
; --=====================================================================================--
   CLASS CFButton, CBBu
      CMETHOD destructor 
      CMETHOD GetFlat
      CMETHOD SetFlat 
      CMETHOD DrawItem
      CMETHOD GetText
      CMETHOD SetText
	  CMETHOD GetActiveTextCol      
      CMETHOD SetActiveTextCol
      CMETHOD GetInactiveTextCol      
      CMETHOD SetInactiveTextCol
      CMETHOD GetActiveBkCol
      CMETHOD SetActiveBkCol
      CMETHOD GetInactiveBkCol
      CMETHOD SetInactiveBkCol
      CMETHOD GetActiveIcon
      CMETHOD SetActiveIcon
      CMETHOD GetHandle 
      CMETHOD GetIconBtn  
      CMETHOD SetIconBtn
      CMETHOD GetCursor
      CMETHOD SetCursor
      CMETHOD IconBtnProc
      m_IsFlat    dd    ?
      m_hIcon     dd    ?
      m_hIconActive dd ?
      m_hCursor  dd    ?
      m_ActiveTextCol dd ?
      m_ActiveBkCol   dd ?
      m_InactiveTextCol dd ?
      m_InactiveBkCol   dd ?
      m_hWnd     dd    ?
      m_lpCtrlProc dd ?
      m_MouseOnButton dd ?
      m_BtnText db 32 dup (?)
      Rect     RECT <>
      
   CFButton ENDS

.data

   BEGIN_INIT 
      dd offset CBBu_destructor_Funct
      dd offset CBBu_GetFlat_Funct
      dd offset CBBu_SetFlat_Funct
      dd offset CBBu_DrawItem_Funct
      dd offset CBBu_GetText_Funct
      dd offset CBBu_SetText_Funct
	  dd offset CBBu_GetActiveTextCol_Funct      
      dd offset CBBu_SetActiveTextCol_Funct
	  dd offset CBBu_GetInactiveTextCol_Funct      
      dd offset CBBu_SetInactiveTextCol_Funct
	  dd offset CBBu_GetActiveBkCol_Funct      
      dd offset CBBu_SetActiveBkCol_Funct
	  dd offset CBBu_GetInactiveBkCol_Funct      
      dd offset CBBu_SetInactiveBkCol_Funct
	  dd offset CBBu_GetActiveIcon_Funct      
      dd offset CBBu_SetActiveIcon_Funct
      dd offset CBBu_GethWnd_Funct
	  dd offset CBBu_GethIconBtn_Funct      
      dd offset CBBu_SethIconBtn_Funct
	  dd offset CBBu_GetCursor_Funct      
      dd offset CBBu_SetCursor_Funct
      dd offset CBBu_IconBtnProc_Funct
      dd FALSE
      dd NULL
      dd NULL
      dd NULL
      dd 0
      dd 0
      dd 0
      dd 0
      dd NULL
      dd NULL
      dd FALSE
      db 32 dup (0)
      dd 0, 0, 0, 0
   END_INIT 
 
.code
; --=====================================================================================--
; #METHOD:      CONSTRUCTOR (:DWORD,:DWORD,:DWORD,:DWORD)
;
; #DESCRIPTION: Initialize Flat Button(Load Icon to display,
;				Set Default text and color,and sublcass this
;				button)..
;
; #PARAM:       hInst      Instance of parent window..
; #PARAM:		hWnd	   Handle of parent window..
; #PARAM:       IconID     the resource identifier of icon
;						   to be setted..
; #PARAM:		BtnID	   resource identifier of this button..
;
; #RETURN:      Nothing..
; --=====================================================================================--
CFButton_Init  PROC uses edi esi lpTHIS:DWORD, hInst:DWORD, hWnd:DWORD,IconID:DWORD,BtnID:DWORD
   SET_CLASS CFButton
   SetObject edi, CFButton
   
   invoke GetDlgItemText,hWnd,BtnID,addr [edi].m_BtnText,32
   invoke GetDlgItem,hWnd,BtnID
   mov [edi].m_hWnd, eax
   invoke GetWindowLong,eax,GWL_STYLE
   or eax,BS_OWNERDRAW	
   invoke SetWindowLong,[edi].m_hWnd,GWL_STYLE,eax 

   invoke LoadIcon,hInst,IconID
   mov [edi].m_hIcon, eax
   
   
   invoke GetSysColor,COLOR_BTNFACE
   mov [edi].m_ActiveBkCol,eax
   mov [edi].m_InactiveBkCol,eax
   invoke GetSysColor,COLOR_BTNTEXT
   mov [edi].m_ActiveTextCol,eax
   mov [edi].m_InactiveTextCol,eax 
	
   invoke SetWindowLong,[edi].m_hWnd,GWL_USERDATA,edi
   invoke SetWindowLong,[edi].m_hWnd,GWL_WNDPROC,[edi].IconBtnProc
   mov [edi].m_lpCtrlProc,eax	
   	
   ReleaseObject edi
   ret
CFButton_Init ENDP

; --=====================================================================================--
; #METHOD:      destructor (NONE)
;
; #DESCRIPTION: Basic destructor setup, no extra procedures are included. ..
;
; #RETURN:      Nothing..
; --=====================================================================================--
CBBu_destructor_Funct  PROC uses edi lpTHIS:DWORD 
   SetObject edi, CFButton
   
   ReleaseObject edi
   ret
CBBu_destructor_Funct  ENDP

; --=====================================================================================--
; #METHOD:      GetFlat(NONE)
;
; #RETURN:      if zero,not a flat button;otherwise is..
; --=====================================================================================--
CBBu_GetFlat_Funct proc uses edi,lpTHIS:dword
	SetObject edi, CFButton
    
   	mov eax,[edi].m_IsFlat
   
    ReleaseObject edi
    ret
CBBu_GetFlat_Funct endp

; --=====================================================================================--
; #METHOD:      SetFlat(:DWORD)
;
; #DESCRIPTION: Set if it is a flat button..
;
; #PARAM:       FFlags   if zero,not a flat button;otherwise is(Default is zero) ..
;
; #RETURN:      Nothing..
; --=====================================================================================--
CBBu_SetFlat_Funct proc uses edi,lpTHIS:dword,FFlags:dword
local @rect:RECT   
	SetObject edi, CFButton

   mov eax,FFlags
   .if eax
   		mov [edi].m_IsFlat,TRUE
   .else
   		mov [edi].m_IsFlat,FALSE
   .endif
	
   invoke GetClientRect,[edi].m_hWnd,addr @rect		   
   invoke InvalidateRect,[edi].m_hWnd,addr @rect,TRUE
   
    ReleaseObject edi
    ret
CBBu_SetFlat_Funct endp

; --=====================================================================================--
; #METHOD:      DrawItem(:DWORD)
;
; #DESCRIPTION: treat with WM_DRAWITEM message.This method should be 
;				called in parent window' message procedure..
;
; #PARAM:       lParam   the lParam parameter of WM_DRAWITEM..
;
; #RETURN:      Nothing..
; --=====================================================================================--
CBBu_DrawItem_Funct  PROC uses edi esi lpTHIS:DWORD, lParam:DWORD
   SetObject edi, CFButton
     mov esi,lParam
     assume esi:ptr DRAWITEMSTRUCT
     
     mov eax, [esi].hwndItem
     .if( eax == [edi].m_hWnd )
		
		.if [edi].m_MouseOnButton == TRUE
			invoke CreateSolidBrush,[edi].m_ActiveBkCol
			invoke FillRect,[esi].hdc,addr [esi].rcItem,eax
			invoke SetTextColor,[esi].hdc,[edi].m_ActiveTextCol
		.else
			invoke CreateSolidBrush,[edi].m_InactiveBkCol
			invoke FillRect,[esi].hdc,addr [esi].rcItem,eax
			invoke SetTextColor,[esi].hdc,[edi].m_InactiveTextCol
		.endif
		invoke SetBkMode,[esi].hdc,TRANSPARENT	

		.if [edi].m_MouseOnButton == TRUE && [edi].m_hIconActive
			invoke DrawIcon,[esi].hdc,[esi].rcItem.left,[esi].rcItem.top,[edi].m_hIconActive	
		.else
			invoke DrawIcon,[esi].hdc,[esi].rcItem.left,[esi].rcItem.top,[edi].m_hIcon
		.endif
		
		.if [edi].m_BtnText != NULL		
  	        INVOKE DrawText,[esi].hdc,addr [edi].m_BtnText,-1,addr  [esi].rcItem,DT_VCENTER or DT_RIGHT or DT_SINGLELINE	
		.endif
	
		.if [edi].m_MouseOnButton == TRUE || [edi].m_IsFlat == FALSE
			invoke DrawEdge,[esi].hdc,addr [esi].rcItem, EDGE_RAISED, BF_RECT		
		.endif
        
        mov eax,[esi].itemState
        .if eax & ODS_SELECTED
  			INVOKE DrawEdge,[esi].hdc,addr [esi].rcItem, EDGE_SUNKEN, BF_RECT
        .endif
        
	.ENDIF
	assume esi:nothing
   
   ReleaseObject edi
   ret
CBBu_DrawItem_Funct  ENDP

; --=====================================================================================--
; #METHOD:      GetText(NONE)
;
; #DESCRIPTION: Get text of this Flat Button ..
;
; #RETURN:      Return a pointer to the button text..
; --=====================================================================================--
CBBu_GetText_Funct proc uses edi lpTHIS:dword
	SetObject edi, CFButton
	
	lea eax,[edi].m_BtnText
	
	ReleaseObject edi
	ret
CBBu_GetText_Funct endp

; --=====================================================================================--
; #METHOD:      SetText (:DWORD)
;
; #DESCRIPTION: Set text of this flat button..
;
; #PARAM:       lpText  the pointer of new text to be setted.
;						must be null-terminated..
;
; #RETURN:      Nothing..
; --=====================================================================================--
CBBu_SetText_Funct proc uses edi,lpTHIS:dword,lpText:dword
	SetObject edi, CFButton
	mov eax,lpText
	.if eax == NULL	
		mov [edi].m_BtnText,NULL
	.else
		invoke lstrcpy,addr [edi].m_BtnText,lpText
	.endif
	
	ReleaseObject edi
	ret
CBBu_SetText_Funct endp

; --=====================================================================================--
; #METHOD:      GetActiveTextCol (NONE)
;
; #DESCRIPTION: Get Text Color when mouse over button..
;
; #RETURN:      Active Text Color..
; --=====================================================================================--
CBBu_GetActiveTextCol_Funct proc uses edi,lpTHIS:dword
	SetObject edi, CFButton
	
	mov eax,[edi].m_ActiveTextCol

	ReleaseObject edi
	ret
CBBu_GetActiveTextCol_Funct endp

; --=====================================================================================--
; #METHOD:      SetActiveTextCol (:DWORD)
;
; #DESCRIPTION: Set Text Color when mouse over button..
;
; #PARAM:       Col  RGB Color should be setted..
;
; #RETURN:      Nothing..
; --=====================================================================================--
CBBu_SetActiveTextCol_Funct proc uses edi,lpTHIS:dword,Col:dword
	SetObject edi, CFButton
	
	mov eax,Col
	mov [edi].m_ActiveTextCol,eax

	ReleaseObject edi
	ret
CBBu_SetActiveTextCol_Funct endp

; --=====================================================================================--
; #METHOD:      GetInactiveTextCol (NONE)
;
; #DESCRIPTION: Get Text color when mouse not over button..
;
; #RETURN:      Inactive Text Color..
; --=====================================================================================--
CBBu_GetInactiveTextCol_Funct proc uses edi,lpTHIS:dword
	SetObject edi, CFButton

	mov eax,[edi].m_InactiveTextCol

	ReleaseObject edi
	ret
CBBu_GetInactiveTextCol_Funct endp

; --=====================================================================================--
; #METHOD:      SetInactiveTextCol (:DWORD)
;
; #DESCRIPTION: Set Text color when mouse not over button..
;
; #PARAM:       Col  RGB Color should be setted..
;
; #RETURN:      Nothing..
; --=====================================================================================--
CBBu_SetInactiveTextCol_Funct proc uses edi,lpTHIS:dword,Col:dword
	SetObject edi, CFButton

	mov eax,Col
	mov [edi].m_InactiveTextCol,eax

	ReleaseObject edi
	ret
CBBu_SetInactiveTextCol_Funct endp

; --=====================================================================================--
; #METHOD:      GetActiveBkCol (NONE)
;
; #DESCRIPTION: Get Back color when mouse over button..
;
; #RETURN:      Active back color..
; --=====================================================================================--
CBBu_GetActiveBkCol_Funct proc uses edi,lpTHIS:dword
	SetObject edi, CFButton

	mov eax,[edi].m_ActiveBkCol 

	ReleaseObject edi
	ret
CBBu_GetActiveBkCol_Funct endp

; --=====================================================================================--
; #METHOD:      SetActiveBkCol (:DWORD)
;
; #DESCRIPTION: Set Back color when mouse over button..
;
; #PARAM:       Col  RGB Color should be setted..
;
; #RETURN:      Nothing..
; --=====================================================================================--
CBBu_SetActiveBkCol_Funct proc uses edi,lpTHIS:dword,Col:dword
	SetObject edi, CFButton

	mov eax,Col
	mov [edi].m_ActiveBkCol,eax

	ReleaseObject edi
	ret
CBBu_SetActiveBkCol_Funct endp


; --=====================================================================================--
; #METHOD:      GetInactiveBkCol (NONE)
;
; #DESCRIPTION: Get Back color when mouse not over button..
;
; #RETURN:      Inactive Back Color..
; --=====================================================================================--
CBBu_GetInactiveBkCol_Funct proc uses edi,lpTHIS:dword
	SetObject edi, CFButton

	mov eax,[edi].m_InactiveBkCol

	ReleaseObject edi
	ret
CBBu_GetInactiveBkCol_Funct endp

; --=====================================================================================--
; #METHOD:      SetInactiveBkCol (:DWORD)
;
; #DESCRIPTION: Set Back color when mouse not over button..
;
; #PARAM:       Col  RGB Color should be setted..
;
; #RETURN:      Nothing..
; --=====================================================================================--
CBBu_SetInactiveBkCol_Funct proc uses edi,lpTHIS:dword,Col:dword
	SetObject edi, CFButton

	mov eax,Col
	mov [edi].m_InactiveBkCol,eax

	ReleaseObject edi
	ret
CBBu_SetInactiveBkCol_Funct endp

; --=====================================================================================--
; #METHOD:      GetActiveIcon(NONE)
;
; #DESCRIPTION: Get button icon when mouse over button..
;
; #RETURN:      Handle of Active Icon ..
; --=====================================================================================--
CBBu_GetActiveIcon_Funct proc uses edi,lpTHIS:dword
	SetObject edi, CFButton
	
	mov eax,[edi].m_hIconActive
	
	ReleaseObject edi
	ret		
CBBu_GetActiveIcon_Funct endp	

; --=====================================================================================--
; #METHOD:      SetActiveIcon(:DWORD,:DWORD)
;
; #DESCRIPTION: Set button icon when mouse over button..
;
; #PARAM:       hInst  Instance of parent window..
; #PARAM:		IconID resource identifier of icon..
;
; #RETURN:      Nothing..
; --=====================================================================================--
CBBu_SetActiveIcon_Funct proc uses edi,lpTHIS:dword,hInst:dword,IconID:dword
	SetObject edi, CFButton
	
	invoke LoadIcon,hInst,IconID
	mov [edi].m_hIconActive,eax
	
	ReleaseObject edi
	ret		
CBBu_SetActiveIcon_Funct endp	

; --=====================================================================================--
; #METHOD:      GethWnd (NONE)
;
; #DESCRIPTION: Get handle of button..
;
; #RETURN:      Handle of button..
; --=====================================================================================--
CBBu_GethWnd_Funct  PROC uses edi lpTHIS:DWORD
   SetObject edi, CFButton

   mov eax, [edi].m_hWnd

   ReleaseObject edi
   ret
CBBu_GethWnd_Funct  ENDP

; --=====================================================================================--
; #METHOD:      GetIconBtn(NONE)
;
; #DESCRIPTION: Get general icon..
;
; #RETURN:      Handle of general icon..
; --=====================================================================================--
CBBu_GethIconBtn_Funct  PROC uses edi lpTHIS:DWORD
   SetObject edi, CFButton

   mov eax, [edi].m_hIcon

   ReleaseObject edi
   ret
CBBu_GethIconBtn_Funct  ENDP

; --=====================================================================================--
; #METHOD:      SetIconBtn(:DWORD,:DWORD)
;
; #DESCRIPTION: Set general icon..
;
; #PARAM:       hInst  Instance of parent window..
; #PARAM:		IconID Icon resource identifier..
;
; #RETURN:      Handle of previous general icon..
; --=====================================================================================--
CBBu_SethIconBtn_Funct  PROC uses edi lpTHIS:DWORD, hInst:DWORD, IconID:DWORD
   SetObject edi, CFButton

   mov eax, [edi].m_hIcon
   push eax
   invoke LoadIcon,hInst,IconID
   mov [edi].m_hIcon, eax
   pop eax

   ReleaseObject edi
   ret
CBBu_SethIconBtn_Funct  ENDP

; --=====================================================================================--
; #METHOD:      GetCursor (NONE)
;
; #DESCRIPTION: Get cursor when mouse over the button..
;
; #RETURN:      Nothing..
; --=====================================================================================--
CBBu_GetCursor_Funct proc uses edi,lpTHIS:dword
	SetObject edi, CFButton 
	
	mov EAX,[edi].m_hCursor	
	
	ReleaseObject edi
	ret
CBBu_GetCursor_Funct endp

; --=====================================================================================--
; #METHOD:      SetCursor (:DWORD,:DWORD)
;
; #DESCRIPTION: Set cursor when mouse over the button..
;
; #PARAM:      hInst  Instance of parent window..
; #PARAM:	   CurID  resource identifier of cursor..
;
; #RETURN:      Nothing..
; --=====================================================================================--
CBBu_SetCursor_Funct proc uses edi,lpTHIS:dword,hInst:dword,CurID:dword
	SetObject edi, CFButton 
	
	invoke LoadCursor,hInst,CurID
	mov [edi].m_hCursor,eax	
	
	ReleaseObject edi
	ret
CBBu_SetCursor_Funct endp

; --=====================================================================================--
; #METHOD:      IconBtnProc (:DWORD,:DWORD,:DWORD,:DWORD)
;
; #DESCRIPTION:  This is a subclass procedure and
;				 should never be called by user		(Special thanks should give: this procedure is mainly from the method of davide_calabro's CButtonST v2.3)..
; --=====================================================================================--
CBBu_IconBtnProc_Funct proc uses edi hWnd:dword,uMsg:dword,wParam:dword,lParam:dword
local 	@rect:RECT	
	
	invoke GetWindowLong,hWnd,GWL_USERDATA
	mov edi,eax
	assume edi:ptr CFButton

	invoke GetClientRect,[edi].m_hWnd,addr @rect
	mov eax,uMsg
	.if eax == WM_MOUSEMOVE
		mov eax,wParam
		.if (eax & MK_LBUTTON) && ([edi].m_MouseOnButton == FALSE)
			;If the mouse enter the button with the left button pressed then do nothing
			invoke CallWindowProc,[edi].m_lpCtrlProc, hWnd, uMsg, wParam, lParam
			ret
		.endif
		invoke GetCapture
		.if eax != [edi].m_hWnd 
			invoke SetCapture,[edi].m_hWnd
			mov [edi].m_MouseOnButton,TRUE
			invoke InvalidateRect,[edi].m_hWnd,addr @rect,TRUE
		.else
			mov eax,lParam
			mov ecx,eax
			and eax,0ffffh
			shr ecx,16
			.if  !(eax >= @rect.left && eax < @rect.right && ecx >= @rect.top && ecx < @rect.bottom)	
				;Redraw only if mouse goes out
				.if [edi].m_MouseOnButton == TRUE
					mov [edi].m_MouseOnButton,FALSE
					invoke InvalidateRect,[edi].m_hWnd,addr @rect,TRUE
				.endif
			
				mov eax,wParam
				.if !(eax & MK_LBUTTON)
					;;If user is NOT pressing left button then release capture!
					invoke ReleaseCapture
				.endif
			.endif		
		.endif		

	.elseif eax == WM_CAPTURECHANGED
		.if [edi].m_MouseOnButton == TRUE
			invoke ReleaseCapture
			invoke InvalidateRect,[edi].m_hWnd,addr @rect,TRUE
		.endif
	.elseif eax == WM_KILLFOCUS
		.if [edi].m_MouseOnButton == TRUE
			mov [edi].m_MouseOnButton,FALSE
			invoke InvalidateRect,[edi].m_hWnd,addr @rect,TRUE
		.ENDIF
	.elseif eax == WM_SETCURSOR	
		.IF [edi].m_hCursor != 0
			invoke SetCursor,[edi].m_hCursor
			xor	eax,eax
			ret
		.endif
	.endif
	invoke CallWindowProc,[edi].m_lpCtrlProc, hWnd, uMsg, wParam, lParam
	assume edi:nothing
	ret
CBBu_IconBtnProc_Funct endp

endif